#include <iostream>
#include <stdlib.h>
#include <stdio.h>

int main()
{
    int h, n;
    scanf("%d %d",&h, &n);
    int noviRed[n];
    int trenutna[n];
    for(int i = 0; i < n; i++)
    {
        trenutna[i] = 1;
    }
    for(int y = 0; y < h; y++)
    {
        for(int x = 0; x < n; x++)
        {
            scanf("%d", &noviRed[x]);
        }
        int dodajNaSledeciSlobodan = 0;
        int poslednjiSlobodan = -1;
        for(int x = 0; x < n; x++)
        {
            if(noviRed[x] == 1)
            {
                trenutna[x] += dodajNaSledeciSlobodan;
                dodajNaSledeciSlobodan = 0;
                poslednjiSlobodan = x;
            }
            else
            {
                if(trenutna[x] % 2 == 0)
                {
                    if(poslednjiSlobodan != -1)
                    {
                        trenutna[poslednjiSlobodan] += trenutna[x] / 2;
                        dodajNaSledeciSlobodan += trenutna[x] / 2;
                        trenutna[x] = 0;
                    }
                    else
                    {
                        dodajNaSledeciSlobodan += trenutna[x];
                        trenutna[x] = 0;
                    }
                }
                else
                {
                    if(poslednjiSlobodan != -1)
                    {
                        if((y + 1) % 2 == 0)
                        {
                            trenutna[poslednjiSlobodan] += trenutna[x] / 2;
                            dodajNaSledeciSlobodan += trenutna[x] / 2 + 1;
                            trenutna[x] = 0;
                        }
                        else
                        {
                            trenutna[poslednjiSlobodan] += trenutna[x] / 2 + 1;
                            dodajNaSledeciSlobodan += trenutna[x] / 2;
                            trenutna[x] = 0;
                        }
                    }
                    else
                    {
                        dodajNaSledeciSlobodan += trenutna[x];
                        trenutna[x] = 0;
                    }
                }
            }
        }
        trenutna[poslednjiSlobodan] += dodajNaSledeciSlobodan;
    }
    for(int i = 0; i < n; i++)
    {
        printf("%d ",trenutna[i]);
    }
}